﻿package us.studiochris.BrushSpider
{
	import flash.display.Sprite;
	import flash.filesystem.File;
	import flash.events.FileListEvent;
	import flash.system.System;
	import flash.system.Capabilities;
	
	/**
	 * Searches for Corel Painter and Corel Painter Brushes
	 * @author studio|chris
	 */
	public class  BrushSpider extends Sprite
	{
		public function BrushSpider():void
		{
			
		}
		
		/*************************************************************

		Get Workspaces from [AppData]/Corel/Painter [Version]/
		Get Libraries from each workspace from [AppData]/Corel/Painter [Version]/[workspace]/Brushes/
		Get Categories from each library from [AppData]/Corel/Painter [Version]/[workspace]/Brushes/[Library]
		Get Brushes from each library from [AppData]/Corel/Painter [Version]/[workspace]/Brushes/[Library]/[category]

		*************************************************************/

		var autoOS:String = Capabilities.os;
		var os:String = "";
		var progFilesDir:String = "";
		var appDataDir:String = "";
		var os_username:String = File.userDirectory.name;
		var appDataFolder:File = File.userDirectory;
		var slashReplace:RegExp = /\\/g;
		var spider:String = "";
		var directory:File = new File();

		//var programFilesDir:String = "";
		var progFiles86:File = new File();
		var genFile:File = new File();
		var winx64:Boolean = false;

		function getOS():void
		{
			switch (autoOS)
			{
				case "Windows XP":
				os = "Windows XP";
				break;
				
				case "Windows Vista":
				os = "Windows Vista";
				break;
				
				case "Windows":
				os = "Windows 7";
				break;
				
				default:
				os = autoOS;
				break;
				
			}
		}



		function setWin64():void
		{
			if(os.match("Windows"))
			{
				progFiles86 = progFiles86.resolvePath('C:/Program Files (x86)');
				
					if(progFiles86.exists)
					{
						os += " 64-bit";
						winx64 = true;
					}		
			}
		}

		function findProgFiles():void
		{
				if (os.match("Windows"))
				{
					if(winx64)
					{
						progFilesDir = "C:/Program Files (x86)/Corel";
					} 
					else
					{
						progFilesDir = "C:/Program Files/Corel";
					}
			
				}

				else if (os.match("Mac"))
				{
					progFilesDir = "/Applications";
				}
				
		}

		function findAppData():void
		{
			if (os.match("Windows XP"))
			{
				appDataDir = "C:/Documents and Settings/" + os_username + "/Application Data/Corel";
			}
			else if (os.match("Windows Vista"))
			{
				appDataDir = "C:/Users/" + os_username + "/AppData/Roaming/Corel";
			}
			else if (os.match("Windows"))
			{
				appDataDir = "C:/Users/" + os_username + "/AppData/Roaming/Corel";
			}
			else if (os.match("Mac"))
			{
				appDataDir = "/Users/" + os_username + "/Library/Application Support/Corel"
			}
		}

		function findPainter():void
		{
			spider = "painter";
			
			directory = directory.resolvePath(progFilesDir);
			directory.getDirectoryListingAsync();
			directory.addEventListener(FileListEvent.DIRECTORY_LISTING, parseDirectory);
			

		}

		function findWorkspaces():void
		{
			spider = "workspaces";
			
			directory = directory.resolvePath(appDataFolder + '/Painter 11');
			directory.getDirectoryListingAsync();
			directory.addEventListener(FileListEvent.DIRECTORY_LISTING, parseDirectory);
			

		}

		function parseDirectory(event:FileListEvent):void
		{
			var files:Array = event.files;
			
			//Search String
			var s:String = "";
			var dbstore:String = "";

		//If searching for Painter
			if(spider == "painter")
			{
				s = "Corel Painter";
				
					for(var i:uint=0; i < files.length; i++)
					{
						if((files[i].name).match(s))
						{
							function checkPainterVersion():String
							{
								return "something";
							}
							
							var preparedHost:Array =
							['NULL', //host_id
							 files[i].name, //host_title
							 (files[i].name).replace('Corel ',''), //host_short_name
							 (files[i].name).replace('Corel Painter ',''), //host_version
							 (files[i].nativePath).replace(slashReplace, "\u002F"), //host_app_folder
							 appDataDir + '/' + (files[i].name).replace('Corel ',''), //host_data_folder
							 files[i].modificationDate, //host_modified_date
							 (files[i].modificationDate).getTime(), //host_modified_timestamp
							 0 //host_status
							 ];
							
							trace (preparedHost);
						}
					}
			}

		//When Looking for Workspaces
			if(spider == "workspaces")
			{
				for(i=0; i < files.length; i++)
					{
						
					}
			}
			
		}

		getOS();
		setWin64();
		findProgFiles();
		findAppData();
		findPainter();
		trace("OS: " + os);
		trace("Corel ProgFiles: " + progFilesDir);
		trace("Corel AppData: " + appDataDir);

		//----------------------------------------------- OPEN FILE
		/*function openClick(event:MouseEvent):void
				{
					var file:File = File.desktopDirectory;
					file.addEventListener(Event.SELECT, openSelect);
					file.browseForOpen("Open",[new FileFilter("Brush Package Files (*.bmpk)", "*.bmpk")]);
				}

		function openSelect(event:Event):void
				{
					var file:File = File(event.target);
					var fileStream:FileStream = new FileStream();
					fileStream.open(file, FileMode.READ);
					var object:Object = fileStream.readObject();
					red.x = object.RED[0];
					red.y = object.RED[1];
					blue.x = object.BLUE[0];
					blue.y = object.BLUE[1];
					fileStream.close();
				}

		function onInvoke(event:InvokeEvent):void
				{
					if(event.currentDirectory != null && event.arguments.length > 0)
					{
						var directory:File = event.currentDirectory;
						var file:File = directory.resolvePath(event.arguments[0]);
						var fileStream:FileStream = new FileStream();
						fileStream.open(file, FileMode.READ);
						var object:Object = fileStream.readObject();
						red.x = object.RED[0];
						red.y = object.RED[1];
						blue.x = object.BLUE[0];
						blue.y = object.BLUE[1];
						fileStream.close();
					} else
					{
						//init();
					}
				}


		*/

		var directory_:File = File.userDirectory;
		//var coreluser:String = directory.url + '/Application Data/Corel/Painter 11/Default/Brushes/Painter Brushes/';

		var filepath:String = progFilesDir + "/Corel Painter 11/Brushes/Painter Brushes/Blenders";

		var filetype:RegExp = /\.(?i:)(?:nib|stk|jpg|xml)$/gixm;

		var painter:File = new File();
		painter = painter.resolvePath(filepath);

		painter.getDirectoryListingAsync();
		painter.addEventListener(FileListEvent.DIRECTORY_LISTING, directoryListingHandler);

		function directoryListingHandler(event:FileListEvent):void
		{
			trace ("Scanning " + filepath);
			var allfiles:Array = event.files;
			allfiles.sort(Array.UNIQUESORT);
			trace ("Found " + allfiles.length.toString() + " files.");
			var brushnames:Array = new Array();
			var filename:String = new String();
			var file:File = new File();

			for (var i:uint = 0; i < allfiles.length; i++)
			{
				//Trim away extra files
				filename = (allfiles[i].name).replace(filetype,'');
				var customvariant:int = filename.indexOf("c_");  
				file = file.resolvePath(allfiles[i].url);
				if(file.isHidden
				|| customvariant != -1  
				|| filename.toLowerCase() == "categorydata"
				|| filename.toLowerCase() == "thumbs.db" //Windows Specific
				|| filename.toLowerCase() == ".ds_store" //Mac Specific
				|| filename.toLowerCase() == ".trash" //Mac Specific
				|| filename.toLowerCase() == "__macosx") //Mac Specific
				{
					continue;
					customvariant = 0; //reset custom variant
				}
				
				
				
				//Push the first legit brush name
				if(i==0){brushnames.push(filename);}
				
				//If the next doesn't match the previous, add it to the array
				if(brushnames[brushnames.length - 1] != filename){
					brushnames.push(filename);
					}
				//trace(filename + "\n");
			}
			trace('Unique Brush Names: ' + brushnames + "\n");
			trace("Number of Unique Brushes Found: " + brushnames.length.toString());
			System.gc();
		}


	}
	
}